<?php

//////////////////////////////////////////////////////////////
//===========================================================
// performance_theme.php
//===========================================================
// SOFTACULOUS VIRTUALIZOR
// Version : 1.0
// Inspired by the DESIRE to be the BEST OF ALL
// ----------------------------------------------------------
// Started by: Alons
// Date:       8th Mar 2010
// Time:       23:00 hrs
// Site:       https://www.virtualizor.com/ (SOFTACULOUS VIRTUALIZOR)
// ----------------------------------------------------------
// Please Read the Terms of use at https://www.virtualizor.com
// ----------------------------------------------------------
//===========================================================
// (c)Softaculous Ltd.
//===========================================================
//////////////////////////////////////////////////////////////

if(!defined('VIRTUALIZOR')){

	die('Hacking Attempt');

}

function performance_theme(){

global $theme, $globals, $cluster, $user, $l, $perfomance;


// Is AJAX mode on
if(optGET('ajax')){	
	
	echo 'cpuusage.push('.$perfomance['cpu'].'); ramusage.push('.$perfomance['ram'].');';
	
	return true;

}

softheader($l['<title>']);

echo '
<div class="bg">
<div class="row mx-auto my-2">
	<div class="col-10">
		<h4 class="text-dark"><i class="fas fa-chart-line"></i> '.$l['<title>'].'</h4>
	</div>
	<div class="col-2 text-right">
		<span><a href="'.$globals['docs'].'Performance" target="_blank" tooltip="'.$l['wiki_help'].'"><i class="icon-help text-dark" ></i></a></span>
	</div>
</div>';

// Is it offline ?
$hypervisor_status = $cluster->statewise($globals['server']);
if($hypervisor_status == 0 || $hypervisor_status == 2){
	show_alert($l['server_status_'.$hypervisor_status] ,"1");
	echo '<div class="e_notice"><b>NOTE : </b>&nbsp; '.$l['server_status_'.$hypervisor_status].'</div>';
	
}else{

echo'
<div class="row mx-auto w-100">
	<div class="col-sm-6">
		<center class="text-dark"><h2><i class="fas fa-microchip"></i>&nbsp;CPU</h2></center>
		<center><div id="cpuholder" style="width:100%; height: 250px;"></div></center>
	</div>
	<div class="col-sm-6">
		<center class="text-dark"><h2><i class="fas fa-memory"></i>&nbsp;RAM</h2></center>
		<center><div id="ramholder" style="width:100%; height: 250px;"></div></center>
	</div>
</div>

';

echo '<script language="javascript" type="text/javascript"><!-- // --><![CDATA[
    
	function makedata(data){
		var fdata = [];
		i = 0;		
		for (x in data){
			fdata.push([i, data[x]]);
			i++;
		}	
		return fdata;		
	}
	
	var tmp = [];
	for (p = 0; p <= 300; p++){
		tmp.push(0);
	}	
	
	var cpuusage = tmp;
	var ramusage = tmp;
	
    // setup plot
    var _options = {
        series: { 
			shadowSize: 0, 
			color: "#007bff",
			lines: { show: true, fill: true, steps: true }
		},		
        yaxis: { min: 0, max: 100 },
        xaxis: { show: false },
		grid: {
			borderColor: "#CCC"
		}
    };
	
	var ram_options = {
        series: { 
			shadowSize: 0, 
			color: "#A244FF",
			lines: { show: true, fill: true, steps: true }
		},		
        yaxis: { min: 0, max: 100 },
        xaxis: { show: false },
		grid: {
			borderColor: "#CCC"
		}
    };
	
    var cpuplot = $.plot($("#cpuholder"), [makedata(cpuusage)], _options);
	var ramplot = $.plot($("#ramholder"), [makedata(ramusage)], ram_options);

    function _update(re) {
	
		if(re.length > 0){
			try{
				eval(re);
			}catch(e){ }
		}
	 	
		// CPU
		if (cpuusage.length > 300){
			cpuusage = cpuusage.slice(1);
		}
		
		cpuplot.setData([ makedata(cpuusage) ]);
		cpuplot.draw();
	 	
		// RAM
		if (ramusage.length > 300){
			ramusage = ramusage.slice(1);
		}
		
		ramplot.setData([ makedata(ramusage) ]);
		ramplot.draw();
    }
	
	function getusage(){
		if(AJAX("'.$globals['index'].'act=performance&ajax=true", "_update(re)")){
			return false;
		}else{
			return true;	
		}
	};

	function startusage(){
		ajaxtimer = setInterval("getusage()", 3000);
		_update("");
	};
	
    startusage();

// ]]></script>';

}

echo '</div>';
softfooter();

}

?>
